<?php
/*
 * Copyright (C) 2009 agorum Software GmbH
 *
 * This file is part of agorum core
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// Most of the code below comes from the companent tutorial on the Joomla Documentation
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
$connected = false;

require_once( JPATH_COMPONENT.DS.'agorum-soap/SoapHelper.php' );

$soapHelper = new SoapHelper();
$connected = false;

if (isset($_SESSION["ticket"])) {
  //check, if we are connected
  $connected = $soapHelper->isConnected($_SESSION["ticket"]);
}

if (!$connected) {
	$plugin =& JPluginHelper::getPlugin('authentication', 'joogorum');
 
 // changed it-service Stefan Steiner
 $version = new JVersion();
	$pluginParams = ($version->RELEASE !='1.5') ? new JRegistry( $plugin->params ) : new JParameter( $plugin->params );

	//if not connected and user password is defined in backend, use this to connect
	if($pluginParams->get( 'user' ) != NULL && $pluginParams->get( 'user' ) != '') {
		//connect or switch user

		if($pluginParams->get( 'user' ) != $_SESSION['user'] || 
			$pluginParams->get('agorum-core-url') != $_SESSION['server']) {

			$repositoryUrl = $pluginParams->get('agorum-core-url');
			$userName = $pluginParams->get( 'user' );
			$passWord = $pluginParams->get( 'password' );

			$_SESSION["user"] = $userName;
			$_SESSION["server"] = $repositoryUrl;
			
			$_SESSION["ac_user"] = $userName;
      $_SESSION["ac_pw"] = $passWord;

			$ticket = $soapHelper->login($userName, $passWord);
   
			if($ticket == null) {
				print('Joogorum: can\'t get session id from agorum server...');
				die();
			}

			$_SESSION["ticket"] = $ticket;
			$connected = $soapHelper->isConnected($_SESSION["ticket"]);
		}
	}
}

if (!$connected && isset($_SESSION["ticket"])) {
	$ticket = $soapHelper->login($_SESSION["ac_user"], $_SESSION["ac_pw"]);
	$_SESSION["ticket"] = $ticket;
	$connected = $soapHelper->isConnected($_SESSION["ticket"]);
}

if ($connected) {
	require_once( JPATH_COMPONENT.DS.'controller.php' );
  //load the view-controller
	if($controller = JRequest::getWord('controller')) {
		$path = JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php';
		if (file_exists($path)) {
			require_once $path;
		} else {
			$controller = '';
		}
	}

	// Create the controller
	$classname    = 'JoogorumController'.$controller;
	$controller   = new $classname( );

	// Perform the Request task
	$controller->execute( JRequest::getVar( 'task' ) );

	// Redirect if set by the controller
	$controller->redirect();
}
else {
	echo "<p>".JText::_('JOOGORUM_NOCONNECT', true )."</p>";
}
?>