<?php 
/*
 * Copyright (C) 2009 agorum Software GmbH
 *
 * This file is part of agorum core
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access');
require_once( JPATH_COMPONENT.DS.'agorum-soap/SoapHelper.php' );

class FolderNode {
  public $children;
}

class JoogorumTmpl {
  
	public static $path;
	public static $session;
	public static $currentNode;

	public static $option;
	public static $view;
	public static $itemid;

	public static $query;
	public static $inSearch;
	public static $startFolderId;
	public static $paginpos;
	
  //get image url of object type
	function getImageURL($className, $locked) {
    $className = strtoupper($className);
    if ($locked == 0) {
      $result = $className.".gif";
    }
    else {
      $result = $className."_locked.gif";
    }

		return $result;
	}


	// get url for onde
	function getURL($node) 	{
		$option = $this->option;
		$view = $this->view;
		$itemid = $this->itemid;
		
		$result = null;
    $id = self::getAttribute($node->attributes[0]);
    $name = self::getAttribute($node->attributes[1]);
    
    $isFolder = self::getAttribute($node->attributes[2]);
		if (strtolower($isFolder)=="false") {
      $soapHelper = new SoapHelper();
      
			$result = $soapHelper->getAgorumUrl()."/roiwebui/wsfiling?action=download&objectId=".
        $id."&wsSessionId=".$_SESSION["ticket"]."' target='_blank";
		}
		else {
      //is a folder, make a link
			$usedPath = self::$path."|".$name."|".$id;
			if (self::$inSearch) {
				$usedPath = $id;
			}
			
			$result = "index.php".
						"?option=".$option.
						"&view=".$view.
						"&Itemid=".$itemid.
						"&folderId=".$id.
						"&name=".$name.
						"&startFolderId=".self::$startFolderId.
						"&path=".$usedPath;
		}

		return $result;
	}  

	function getURLSearch($name, $id) 	{
		$option = $this->option;
		$view = $this->view;
		$itemid = $this->itemid;
		
		$result = null;
		
		//is a folder, make a link
		$result = "index.php".
					"?option=".$option.
					"&view=".$view.
					"&Itemid=".$itemid.
					"&folderId=".$id.
					"&name=".$name.
					"&startFolderId=".self::$startFolderId.
					"&path=".self::$path;

		return $result;
	}  

	function getURLPaginator($name, $id, $pos, $query) 	{
		$option = $this->option;
		$view = $this->view;
		$itemid = $this->itemid;
		
		$result = null;
		
		//is a folder, make a link
		$result = "index.php".
					"?option=".$option.
					"&view=".$view.
					"&Itemid=".$itemid.
					"&folderId=".$id.
					"&name=".$name.
					"&startFolderId=".self::$startFolderId.
					"&paginpos=".$pos;
		if ($query != "") {
			$result = $result."&query=".$query."&inSearch=true";
		}
		$result = $result."&path=".self::$path;

		return $result;
	}  
	
	function getURLPDF($node) 	{
		$option = $this->option;
		$view = $this->view;
		$itemid = $this->itemid;
		
		$result = null;
    $id = self::getAttribute($node->attributes[0]);
    $name = self::getAttribute($node->attributes[1]);
    
    $isFolder = self::getAttribute($node->attributes[2]);
		if (strtolower($isFolder)=="false") {
      $soapHelper = new SoapHelper();
      print("<td width=100%>&nbsp;&nbsp;<a href='");
      
			$result = $soapHelper->getAgorumUrl()."/roiwebui/wsfiling?action=download&targetFormat=pdf&objectId=".
        $id."&wsSessionId=".$_SESSION["ticket"]."' target='_blank";
      
      print($result);
      print("'>");
      print("[PDF]");
      print("</a>&nbsp;&nbsp;</td>");
		}
    else {
      print("<td width=100%>&nbsp;</td>");
    }

		return $result;
	}    
  //Output one line of file/folder table
	function outputRow($node) {
    if (self::checkValidClass(self::getAttribute($node->attributes[3]))) {
      print("<tr><td height=20 valign='middle'>");
	  
	  print("<img align='middle' src='".JURI::root()."components/com_joogorum/images/".
        self::getImageURL(self::getAttribute($node->attributes[3]), self::getAttribute($node->attributes[4]))."'></td>".
        "<td width=100%>&nbsp;&nbsp;<a href='");
      
      print(self::getURL($node));
      print("'>");
      print(self::getAttribute($node->attributes[1]));
      print("</a></td>");
      self::getURLPDF($node);
      print("<td width=100><nobr>".self::getDate($node->attributes[5])."</nobr></td>");
      print("</tr>");
    }
	}
  
  //get a displayable date
  function getDate($sDate) {
    $sDate = self::getAttribute($sDate);
    $eDate = "";
    $eDate = substr($sDate, 0, 4)."-".substr($sDate, 4, 2)."-".substr($sDate, 6, 2);
    $eDate = $eDate." ".substr($sDate, 8, 2).":".substr($sDate, 10, 2).":".substr($sDate, 12, 2);
    
    $pTime = strtotime($eDate);
    $returnDate = strftime("%Y/%m/%d %H:%m:%S", $pTime);
    
    return $returnDate;
  }

  //strip of leading quotes
  function getAttribute($attribute) {
    return trim($attribute,"\"");
  }
  
  //check if this is a class we want to show
  function checkValidClass($className) {
    $className = strtoupper($className);
    if ($className == "FOLDEROBJECT") {
      return true;
    }
    if ($className == "FILEOBJECT") {
      return true;
    }
    if ($className == "ASMBMOUNTPOINT") {
      return true;
    }
    if ($className == "AFSMOUNTPOINT") {
      return true;
    }
    if ($className == "ASMBFILE") {
      return true;
    }
    if ($className == "ASMBFOLDER") {
      return true;
    }
    if ($className == "AFSFILE") {
      return true;
    }
    if ($className == "AFSFOLDER") {
      return true;
    }
    return false;
  }
  
  //Draw the file/folder-table
	function outputTable($title, $node, $type_filter, $empty_message, $isSearch, $resultCount, $name, $folderId) {
		$amount = 50;
		
		$text = JText::_( 'JOOGORUM_SEARCHFIELD', true );
		$qValue = $text;
		if (self::$query != "") {
			$qValue = self::$query;
		}
		$itemCount = 0;
		foreach ($node->children as $child) {
			$itemCount++;
		}		
		
		print(
		'<table cellspacing=0 cellpadding=0 border=0 width=95% align=center>'.
		'   <tr>'.
		'       <td class="headLine">'.
		'         '.$title.''.
		'       </td>'.
		'   </tr>'.
		'   <tr>'.
		'       <td>');
		
		print(
		'         <input id="inputquery" class="inputbox" type="text" name="query" value="'.$qValue.'" onfocus="if(this.value==\''.$text.'\') this.value=\'\';" onblur="if(this.value==\'\') this.value=\''.$text.'\';">');
		
		print(
		'       </td>'.
		'   </tr>');

		//paginator
		$endCount = self::$paginpos + $amount;
		$hasMore = true;
		$hasPrev = false;
		if ($endCount >= $itemCount) {
			$endCount = $itemCount;
			$hasMore = false;
		}
		if (self::$paginpos > 0) {
			$hasPrev = true;
		}

		print('<tr><td>'); 
		//start
		if ($hasPrev) {
			$pos = 0;
			print('<a href="'.self::getURLPaginator($name, $folderId, $pos, self::$query).'">|&#x25C4;</a>&nbsp;');
		}
		else {
			print('|&#x25C4;&nbsp;');
		}
		
		//prev
		if ($hasPrev) {
			$pos = self::$paginpos - $amount;
			if ($pos < 0) $pos = 0;
			print('<a href="'.self::getURLPaginator($name, $folderId, $pos, self::$query).'">&#x25C4;</a>&nbsp;');
		}
		else {
			print('&#x25C4;&nbsp;');
		}
		
		//next
		if ($hasMore) {
			$pos = self::$paginpos + $amount;
			if ($pos > $itemCount) $pos = $itemCount-$amount;
			print('<a href="'.self::getURLPaginator($name, $folderId, $pos, self::$query).'">&#x25BA;</a>&nbsp;');
		}
		else {
			print('&#x25BA;&nbsp;');
		}
		
		//end
		
		if ($hasMore) {
			$pos = $itemCount-$amount;
			print('<a href="'.self::getURLPaginator($name, $folderId, $pos, self::$query).'">&#x25BA;|</a>&nbsp;');
		}
		else {
			print('&#x25BA;|&nbsp;');
		}
		
		print('&nbsp;('.(self::$paginpos+1).'&nbsp;-&nbsp;'.$endCount.'&nbsp;/&nbsp;'.$itemCount.')');
		print('</td></tr>');
		
		$plugin =& JPluginHelper::getPlugin('authentication', 'joogorum');

  // changed by it-service Stefan Steiner
  $version = new JVersion();
		$pluginParams = ($version->RELEASE !='1.5') ? new JRegistry( $plugin->params ) : new JParameter( $plugin->params );

  $maxsearchresult = $pluginParams->get( 'maxsearchresult' );
		
		if ($isSearch == true && count($node->children) > $maxsearchresult) {
			$text = JText::_( 'JOOGORUM_SEARCHRESULT_TOOMUCH_FOUND', true );
			print('<tr><td>');
			print($text);
			print('</td></tr>');
		}
		
		print(
		'   <tr>'.
		'       <td bgcolor="white" style="padding-top:6px;">'.
		'           <table border="0" width="100%" class="listContent">');


		$c = 0;
		foreach ($node->children as $child) {
			if ($c >= self::$paginpos && $c < self::$paginpos+$amount) {
				self::outputRow($child);
			}
			$c++;
		}

		print(
		'         </table>'.
		'      </td>'.
		'   </tr>'.
		'</table>');
	}

  //Draw Breadcrumbs
	function drawBreadcrumb($path) {
		$session = $this->session;
		if (isset($this->store)) $store = $this->store;
		
		$option = $this->option;
		$view = $this->view;
		$itemid = $this->itemid;
		
		print(
			'<table border="0" width="95%" align="center">'.
			'   <tr>'.
			'      <td>');

		$values = preg_split("/\|/", $path);
		$home = $values[0];
		$homeId = $values[1];
		$path = $home."|".$homeId;
		$id_map = array();
		for ($counter = 2; $counter < count($values); $counter += 2) {
			$id_map[$values[$counter+1]] = $values[$counter];
		}

		print("<a href='index.php?option=".$option."&view=".$view."&Itemid=".$itemid."&folderId=".$homeId."'><strong>".$home."</strong></a>");
		foreach($id_map as $id=>$name) {
			$path .= '|'.$name.'|'.$id;
			print(" &gt; <a href='index.php?option=".$option."&view=".$view."&Itemid=".$itemid."&folderId=".$id."&path=".$path."'><strong>".$name."</strong></a>");
		}

		print(
		'      </td>'.
		'   </tr>'.
		'</table>');
	}
}

//End of template
?>
  
<!-- Header -->
<!--
<table cellspacing="0" cellpadding="2" width="95%" align="center">
	<tr>
		<td width=100%>
		</td>
	</tr>
</table>
<br />
-->

<?php
// Get the values and set the class variables
JoogorumTmpl::$session = $this->session;
if (isset($this->currentNode)) JoogorumTmpl::$currentNode = $this->currentNode;
JoogorumTmpl::$query = "";

JoogorumTmpl::$option = $this->option;
JoogorumTmpl::$view = $this->view;
JoogorumTmpl::$itemid = $this->itemid;

$folderId = JRequest::getVar( 'folderId' );
$startFolderId = JRequest::getVar( 'startFolderId' );

$name = JRequest::getVar( 'name' );
$inSearch = JRequest::getVar( 'inSearch' );

$savedPath = JRequest::getVar( 'path' );
$actPath = JRequest::getVar( 'path' );
if (!isset($actPath) || $actPath == "") {
  $actPath = JText::_( 'JOOGORUM_STARTNAME', true )."|".$folderId;
	$name = "Start";
}

if (strpos($actPath, "|") > 0) {
	$sfArr = preg_split("/\|/", $actPath);
	$startFolderId = $sfArr[1];
}
JoogorumTmpl::$startFolderId = $startFolderId;

//JoogorumTmpl::$name = JRequest::getVar( 'name' );
//JoogorumTmpl::$folderId = $folderId;

$paginpos = JRequest::getVar( 'paginpos' );
if (!isset($paginpos) || $paginpos == "") $paginpos = 0;
JoogorumTmpl::$paginpos = $paginpos;

if (isset($inSearch) && $inSearch == "true") {
	JoogorumTmpl::$inSearch = true;
	$query = JRequest::getVar( 'query' );
	JoogorumTmpl::$query = $query;
	
	//load the items with full text search
	$soapHelper = new SoapHelper();
	$requestAttributes = array ( "ID", "NAME", "ISFOLDER", "CLASSNAME", "LOCKSTATE", "LASTMODIFYDATE" );
	$searchResponseBean = $soapHelper->search($_SESSION["ticket"], $folderId, $requestAttributes, $query);
	$resultCount = $searchResponseBean->resultCount;
	
	//var_dump($searchResponseBean);
	$items = $searchResponseBean->items;
}
else {
	JoogorumTmpl::$inSearch = false;
	//load the items of the folder and the full-path
	$soapHelper = new SoapHelper();
	$requestAttributes = array ( "ID", "NAME", "ISFOLDER", "CLASSNAME", "LOCKSTATE", "LASTMODIFYDATE" );
	$items = $soapHelper->getItems($_SESSION["ticket"], $folderId, $requestAttributes);
}

$breadCrumbPath = $actPath;

if (strpos($breadCrumbPath, "|") == false) {
	//start folder id is always the second element in path
	$breadCrumbPath = $soapHelper->getPath($_SESSION["ticket"], $name, $savedPath, $startFolderId);
}

JoogorumTmpl::$path = $breadCrumbPath;

// Output the breadcrumb
JoogorumTmpl::drawBreadcrumb($breadCrumbPath);
$urlSearch = JoogorumTmpl::getURLSearch($name, $folderId);

?>

<br />
<link rel="stylesheet" href="<?php print(JURI::root()); ?>components/com_joogorum/styles.css" type="text/css"/>
<form action="<?php echo $urlSearch;?>&inSearch=true" method="post">

<?php
// Output the content (files)
JoogorumTmpl::$currentNode = new FolderNode();
JoogorumTmpl::$currentNode->children = $items;
if (isset($inSearch) && $inSearch == "true") {
	$text = '';
	if($resultCount != 0 && $resultCount != '0' && $resultCount != NULL && $resultCount != '')
	{
		$text = JText::_( 'JOOGORUM_SEARCHRESULT', true );
	}
	else
	{
		$text = JText::_( 'JOOGORUM_SEARCHRESULT_NOTHING_FOUND', true );
	}
	
	JoogorumTmpl::outputTable($text, JoogorumTmpl::$currentNode, "", "There is no content", true, $resultCount, $name, $folderId);
}
else {
	JoogorumTmpl::outputTable(JText::_( 'JOOGORUM_HEADER', true ), JoogorumTmpl::$currentNode, "", "There is no content", false, $resultCount, $name, $folderId);
}
?>

</form>