<?php

/*
 * Copyright (C) 2009 agorum Software GmbH
 *
 * This file is part of agorum core
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
class SoapHelper {
  
  private $wsdlPath = "/dynawebservices/wsdl/";
  
  public function __construct() {
  }

  /**
      * get the URL from the auth plugin of joogorum
      */
  public function getAgorumUrl() {
		// Get the URL of the agorum SOAP
		$plugin =& JPluginHelper::getPlugin('authentication', 'joogorum');
  
  // changed it-service Stefan Steiner
  $version = new JVersion();
	 $pluginParams = ($version->RELEASE !='1.5') ? new JRegistry( $plugin->params ) : new JParameter( $plugin->params );

		// Set the variables
    ini_set('default_socket_timeout', 30);
    ini_set('tcp_nodelay', 1);
    
		return $pluginParams->get('agorum-core-url');
  }
  
  public function login($userName, $passWord) {
    $wsdlUrl = $this->getAgorumUrl().$this->wsdlPath;
      
    $options = array("connection_timeout" => 30);

    $client = new SoapClient($wsdlUrl."StaticNgOsService", $options); 
    
    $loginRequestBean = array (
      'needsConnection' => false,
      'serviceMethod' => 'login',
      'transactionId' =>  '',
      'wsSessionId' => '',
      'userName' => $userName,
      'passWord' => $passWord);
    
    $result = $client->login($loginRequestBean); 
    if ($result->connected) {
      return $result->wsSessionId; 
    }
    else {
      return null;
    }
	}
	
}
?>