<?php
/*
 * Copyright (C) 2009 agorum Software GmbH
 *
 * This file is part of agorum core
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die();
jimport('joomla.event.plugin');

/**
 * joogorum Authentication Plugin
 */
class plgAuthenticationJoogorum extends JPlugin {
  
	/**
	 * Constructor
	 */
	function plgAuthenticationJoogorum(& $subject) {
		parent::__construct($subject);
	}

	/**
	 * This method should handle any authentication and report back to the subject for Joomla > 1.5  (it-service Stefan Steiner)
	 */
	function onUserAuthenticate( $credentials, $options, &$response )
	{
		require_once (dirname(__FILE__).'/agorum-soap/SoapHelper.php');

		// Get the URL of the agorum SOAP
		$plugin =& JPluginHelper::getPlugin('authentication', 'joogorum');
  
  // changed it-service Stefan Steiner
  $version = new JVersion();
	 $pluginParams = ($version->RELEASE !='1.5') ? new JRegistry( $plugin->params ) : new JParameter( $plugin->params );

		$repositoryUrl = $pluginParams->get('agorum-core-url');
    if($pluginParams->get( 'user' ) != NULL && $pluginParams->get( 'user' ) != '')
    {   
      $userName = $pluginParams->get( 'user' );
      $passWord = $pluginParams->get( 'password' );
    }
    else
    {
      $userName = $credentials['username'];
      $passWord = $credentials['password'];
    }

		// Connect to agorum core
		$ticket = null;
		
		try {
			// Try to create a session
			$ticket = null;
      
      $soapHelper = new SoapHelper($repositoryUrl);
      $_SESSION["user"] = $userName;
      $_SESSION["server"] = $repositoryUrl;
      
      $ticket = $soapHelper->login($userName, $passWord);

      $_SESSION["ticket"] = $ticket;
      $_SESSION["ac_user"] = $userName;
      $_SESSION["ac_pw"] = $passWord;
      
      if ($ticket != null) {
        $response->status = JAUTHENTICATE_STATUS_SUCCESS;

        $response->username = $credentials['username'];
        $response->email = $credentials['username']."@agorumcore.com";
        $response->fullname = $credentials['username'];
      }
      else {
        // Wrong username or password creates an exception
        $response->status = JAUTHENTICATE_STATUS_FAILURE;
        $response->error_message = 'Authentication failed';
      }
			
		}
		catch (Exception $e) {
      error_log("Error ".$e, 0);
			// Wrong username or password creates an exception
			$response->status = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = 'Authentication failed';
		}

	}


	/**
	 * This method should handle any authentication and report back to the subject for Joomla 1.5  (it-service Stefan Steiner)
	 */
	function onAuthenticate( $credentials, $options, &$response )          
	{
   $this->onUserAuthenticate( $credentials, $options, &$response );
	}
}
?>
